/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the command widget.
***************************************************************/

/*command.c*/

#include <Xm/Xm.h>
#include <Xm/Command.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel;
Widget command;
Widget button;

void command_enteredCB(w,client_data,call_data)
    Widget w; 
    int client_data; 
    XmCommandCallbackStruct *call_data;
/* handle callbacks generated when the command is entered. */
{
    char *s;

    XmStringGetLtoR(call_data->value,char_set,&s);
    printf("command entered='%s'\n",s);
    XtFree(s);
}

void command_changedCB(w,client_data,call_data)
    Widget w; 
    int client_data; 
    XmCommandCallbackStruct *call_data;
/* handle callbacks generated when the command is changed. */
{
    char *s;

    XmStringGetLtoR(call_data->value,char_set,&s);
    printf("command changed='%s'\n",s);
    XtFree(s);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* create the command widget. */
    ac = 0;
    XtSetArg(al[ac], XmNpromptString,
       XmStringCreateLtoR("Enter a command", char_set));  ac++;
    command = XmCreateCommand(toplevel, "command", al, ac);
    XtAddCallback (command, XmNcommandEnteredCallback, 
        command_enteredCB, NULL);
    XtAddCallback (command, XmNcommandChangedCallback, 
        command_changedCB, NULL);
    XtManageChild(command);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
