/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the drawn button widget. See Chapter
17 for more information on drawing areas.
***************************************************************/

/*drawn_button.c*/

#include <Xm/Xm.h>
#include <Xm/DrawnB.h>

XtAppContext context;

Widget toplevel, button;
GC gc;

void buttonCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XmDrawnButtonCallbackStruct *call_data;
{
    printf("click_count = %d \n",call_data->click_count);
}

void exposeCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XmDrawnButtonCallbackStruct *call_data;
{
    XDrawLine(XtDisplay(w),XtWindow(w),gc,0,0,100,100);
}

void setup_gc()
/* set up the graphics contexts (see Chapter 17). */
{
    int foreground,background;
    Arg al[10];
    int ac;
    XGCValues vals;

    /* get the current fg and bg colors. */
    ac=0;
    XtSetArg(al[ac], XmNforeground, &foreground); ac++;
    XtSetArg(al[ac], XmNbackground, &background); ac++;
    XtGetValues(button, al, ac);

    /* create the copy gc. */
    vals.foreground = foreground;
    vals.background = background;
    gc= XtGetGC(button, GCForeground | GCBackground, &vals);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* create the drawn button. */
    ac=0;
    XtSetArg (al[ac], XmNmultiClick, XmMULTICLICK_KEEP);  ac++;
    XtSetArg (al[ac], XmNwidth, 100);  ac++;
    XtSetArg (al[ac], XmNheight, 100);  ac++;
    button=XmCreateDrawnButton(toplevel,"button",al,ac);
    XtManageChild(button);
    XtAddCallback (button, XmNactivateCallback, buttonCB, NULL);
    XtAddCallback (button, XmNexposeCallback, exposeCB, NULL);

    setup_gc();

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
