/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the scrolled window widget.
***************************************************************/

/*scrolled_window.c*/

#include <Xm/Xm.h>
#include <Xm/ScrollBar.h>
#include <Xm/DrawingA.h>
#include <Xm/ScrolledW.h>

XtAppContext context;

Widget toplevel, scroll1, scroll2, da, win;

void scrollCB(w,client_data,call_data)
    Widget w;
    int client_data;
    XmAnyCallbackStruct *call_data;
/* handle callbacks from either scrollbar. */
{
    int value;
    Arg al[10];
    int ac;

    ac=0;
    XtSetArg(al[ac], XmNvalue, &value); ac++;
    XtGetValues(w,al,ac);

    printf("bar=%d value = %d\n",client_data,value);
}

handle_click(w,client_data,event)
    Widget w;
    XtPointer client_data;
    XEvent *event;
{
    printf("%d %d\n",event->xbutton.x,event->xbutton.y);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* create scrolled window. */
    ac=0;
    XtSetArg(al[ac],XmNscrollingPolicy,XmAPPLICATION_DEFINED); ac++;
    XtSetArg(al[ac],XmNscrollBarDisplayPolicy,XmSTATIC); ac++;
    XtSetArg(al[ac],XmNscrollBarPlacement,XmBOTTOM_RIGHT); ac++;
    win=XmCreateScrolledWindow(toplevel,"win",al,ac);
    XtManageChild(win);

    /* create scroll bars and drawing area. */
    ac=0;
    XtSetArg(al[ac],XmNminimum,0); ac++;
    XtSetArg(al[ac],XmNmaximum,1000); ac++;
    XtSetArg(al[ac],XmNorientation,XmHORIZONTAL); ac++;
    scroll1=XmCreateScrollBar(win,"scroll1",al,ac);
    XtManageChild(scroll1);
    XtAddCallback (scroll1, XmNvalueChangedCallback, scrollCB, 1);

    ac=0;
    XtSetArg(al[ac],XmNminimum,0); ac++;
    XtSetArg(al[ac],XmNmaximum,1000); ac++;
    scroll2=XmCreateScrollBar(win,"scroll2",al,ac);
    XtManageChild(scroll2);
    XtAddCallback (scroll2, XmNvalueChangedCallback, scrollCB, 2);

    ac=0;
    da=XmCreateDrawingArea(win,"da",al,ac);
    XtManageChild(da);
    XtAddEventHandler(da, ButtonPressMask, FALSE,
        handle_click, NULL);

    /* link scroll bars and drawing area into scrolled window. */ 
    XmScrolledWindowSetAreas(win,scroll1,scroll2,da);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
